--Mount Module

function Player:IsCombatMount()
	local Mount	= self:GetMount()
	if Mount~=nil then
		return (Mount.GetTurnRate~=nil)
	end
end

function Player:IsMounted()
	local Mount	= self:GetMount()
	return Mount~=nil 
end

handleMount = AddCallback(Player, "MountChanged", function(sender, args) scanMount() end)

function scanMount()
	local IsMounted=		Player:IsMounted()
	local IsCombatMount=	Player:IsCombatMount()

	for i=1,#Bar do
		if Bar[i].Data.Mount~=nil then			
			if 		Bar[i].Data.Mount==1 then	--1: Combat mount
				Bar[i].Mount=IsCombatMount
			elseif 	Bar[i].Data.Mount==2 then 	--2: NOT combat mounted.
				Bar[i].Mount=not(IsCombatMount)
			elseif	Bar[i].Data.Mount==3 then 	--3: Non-combat mounted.
				Bar[i].Mount=not(IsCombatMount) and IsMounted
			elseif	Bar[i].Data.Mount==4 then 	--4: Not Non-combat mounted.
				Bar[i].Mount=IsCombatMount or not(IsMounted)
			elseif	Bar[i].Data.Mount==5 then 	--5: Mounted.
				Bar[i].Mount=IsMounted
			elseif	Bar[i].Data.Mount==6 then 	--6: Not mounted.
				Bar[i].Mount=not(IsMounted)
			end
			
			Bar[i]:Show()
		end
	end
end

--Now the options dialog portions.
function Mountoptions(self,contextMenu,contextMenuItems)
	local MountBar= Turbine.UI.MenuItem( "Mount visibility;");
		contextMenu.Mount = MountBar:GetItems()
		
		local val=self.Data.Mount
		local MountBarMenu={}

			MountBarMenu[1]=Turbine.UI.MenuItem("Show when on a Combat Mount.",true,val==1)
			MountBarMenu[1].Click=function() self.Data.Mount=1 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[1])
			
			MountBarMenu[2]=Turbine.UI.MenuItem("Show when not on a Combat Mount.",true,val==2)
			MountBarMenu[2].Click=function() self.Data.Mount=2 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[2])
			
			MountBarMenu[3]=Turbine.UI.MenuItem("Show when on a Normal Mount.",true,val==3)
			MountBarMenu[3].Click=function() self.Data.Mount=3 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[3])
			
			MountBarMenu[4]=Turbine.UI.MenuItem("Show when not on a Normal Mount.",true,val==4)
			MountBarMenu[4].Click=function() self.Data.Mount=4 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[4])
			
			MountBarMenu[5]=Turbine.UI.MenuItem("Show when on Any Mount.",true,val==5)
			MountBarMenu[5].Click=function() self.Data.Mount=5 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[5])
			
			MountBarMenu[6]=Turbine.UI.MenuItem("Show when not on Any Mount.",true,val==6)
			MountBarMenu[6].Click=function() self.Data.Mount=6 scanMount() end
			contextMenu.Mount:Add(MountBarMenu[6])			
			
			MountBarMenu[7]=Turbine.UI.MenuItem("Clear setting",true)
			MountBarMenu[7].Click=function() self.Data.Mount=nil end
			contextMenu.Mount:Add(MountBarMenu[7])			
		
	contextMenuItems:Add( MountBar )
end

--Option Box functions

table.insert(Opt.Module,
	function()
		Opt.MountCB=CollapseBox("Mount Options","f",1,true)
		Opt.ListBox:AddItem(Opt.MountCB)
	
			Opt.Mount=Opt.DropDown(
			{	"No setting",
				"on a Combat Mount.",
				"not on a Combat Mount.",
				"on a Normal Mount.",
				"not on a Normal Mount.",
				"on Any Mount.",
				"not on Any Mount."
				},
			
			function(k,i)
				if k==0 then
					k=nil
				end
				
				Bar[i].Data.Mount=k
				
				scanMount()
			end,
			"Show when:")
		Opt.MountCB.Content:AddItem(Opt.Mount)
		table.insert(Opt.source,"Mount")

		end)

scanMount()